<?php
header('Content-Type: application/json;charset= utf-8');
echo("Arranca!!!!" .  PHP_EOL);
require("dl.php");


$sqlname3 = "127.0.0.1";
$username3 = "Santana1966";
$password3 = "Santana1966";
$db3 = "cat_conexiones";

$con_local = mysqli_connect($sqlname3, $username3, $password3, $db3);
if(!$con_local){
    echo("Finaliza ejecución. NO SE PUEDE CONECTAR SERVIDOR LOCAL!!!!" .  PHP_EOL);
    exit;}
mysqli_set_charset($con_local,"utf8");


$DB_HOST = "www.imsaninsp.com";
$DB_USER = "imsanins_daniel";
$DB_PASS = "Santana1966";
$DB_NAME = "imsanins_cat_conexiones";

$con_produccion = mysqli_connect($DB_HOST, $DB_USER, $DB_PASS, $DB_NAME);
if(!$con_produccion){
    echo("Finaliza ejecución. NO SE PUEDE CONECTAR SERVIDOR DE PRODUCCION!!!!" .  PHP_EOL);
    exit;}
mysqli_set_charset($con_produccion,"utf8");

$sqlname = "www.dlgeo.com";
$username = "uyinfrai_Santana";
$password = "Santana1966";
$db = "uyinfrai_cat_conexiones";
$con_desarrollo = mysqli_connect($sqlname, $username, $password, $db);
if(!$con_desarrollo){
    echo("Finaliza ejecución. NO SE PUEDE CONECTAR SERVIDOR DE DESARROLLO!!!!" .  PHP_EOL);
    exit;}
mysqli_set_charset($con_desarrollo,"utf8");

//borro_PRESENTE_EN_SISTEMA_DE_CONEXIONES($con_produccion);
//borro_ccon($con_produccion);
//cargo_log($con_produccion);



//creo_tabla_hist($con_local);
//orrijo_fechas2($con_produccion);
//recalculo_campo_sur($con_produccion);

//borro_duplicados_historial_SUR($con_produccion);


//borro_sic_viejos($con_produccion);
//borro_sur_todos($con_produccion);
//corrijo_sur($con);
//normalizo_datos($con);
//chequeo_fechas($con);
//corrijo_fechas($con);
//borro_sur_viejos($con);



//corrijo_fechas_ccon($con_local);

//corrijo_fechas_ccon_en_perdidos($con_local);
borro_duplicados_historial($con_produccion);

function cmp_fechas($a, $b)
{
    $a = $a["fecha"];
    $b = $b["fecha"];
    $fecha1 = dl_fecha::dl_fecha_texto_a_date($a);
    $fecha2 = dl_fecha::dl_fecha_texto_a_date($b);
    return  $fecha1 > $fecha2;
}

function borro_duplicados_historial($con)
{
$nombre_respaldo = "sql/ajuste_historial.sql";
$archivo_sql = fopen($nombre_respaldo,"w"); 
    echo ("empieza borro duplicados......." . PHP_EOL);
set_time_limit(50000);
$sql = "SELECT id, historial FROM conexiones WHERE historial LIKE '%SUR,%' OR historial LIKE '%SIC,%' OR historial LIKE '%CCON,%' ";
$resultado = mysqli_query($con,$sql);
$cant_duplicados = 0;
$contador = 0;
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{
							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            $historial_array2 = array();
                            foreach($historial_array as $clave)
                            {
                                $yaexiste = false;
                                $fecha_historial = $clave['fecha'];
                                $descripcion_historial = $clave['descripcion'];
                                $usuario_historial = $clave['usuario'];
                                foreach($historial_array2 as $clave2)
                                {
                                    $fecha_historial2 = $clave2['fecha'];
                                    $descripcion_historial2 = $clave2['descripcion'];
                                    $usuario_historial2 = $clave2['usuario'];
                                    if ($descripcion_historial == $descripcion_historial2)
                                    {
                                        $yaexiste = true;
                                    }
                                }    
                                if ($yaexiste === false) {
                                    array_push($historial_array2,$clave);
                                }else
                                {
                                    $cant_duplicados++;
                                }
                            }  
                            usort($historial_array2,"cmp_fechas");
                            $historial2 = json_encode($historial_array2);
                            $recalcular = recalculo_campos_historial_completo($historial2);
                            if ($recalcular['sur'] != '')
                            {
                                $sqlsur= ", sur = '" . $recalcular['sur'] . "'";
                            }
                            else
                            {
                                $sqlsur= ", sur = 'Sin reclamos' ";
                            }
                            if ($recalcular['sic'] != '')
                            {
                                $sqlsic = ", tramite = '" . $recalcular['sic'] . "'";
                            }else
                            {
                                $sqlsic = ", tramite = 'Sin tramite' ";
                            }
                            $sql2 = "UPDATE conexiones SET historial = '" . $historial2 . "' " . $sqlsur . $sqlsic .  " WHERE id =" . $id;  
                            fwrite($archivo_sql,$sql2 . ";" . PHP_EOL);
                            //$resultado2 = mysqli_query($con,$sql2); 
                            $contador++;
                            echo($contador . " - " . $id . PHP_EOL);
        }  
    }
}	
echo "Se eliminaron " . $cant_duplicados . " de historial!";
fclose($archivo_sql); 
}
function recalculo_campos_historial_completo($historial)
{
    $valor_sur = '';
    $tramite_catastro = '';
                    $historial_array = json_decode($historial,true);
                    foreach($historial_array as $clave2)
                    {
                               $elemento_historial = $clave2['descripcion'];
                               $posicion = substr($elemento_historial,0,3);
                                if ($posicion == 'SUR') 
                                {
                                    $sur_array = explode(",",$elemento_historial);
                                    $tipo = $sur_array[2];
                                    $estado = $sur_array[9];
                                    $prioridad = $sur_array[6];                     
                                    switch ($tipo)
                                    {
                                        case "Conexion Nueva":
                                            $valor_sur = "SUR Nueva";
                                        break;
                                        case "Conexion Rota":
                                            $valor_sur = "SUR Rota";
                                        break;
                                        default:
                                            $valor_sur = "SUR Obstruida";
                                    }
                                    if ($estado != 'Finalizado' && $prioridad == 'Alta')
                                    {
                                        $valor_sur .= " Alta Prioridad";
                                    }
                                    else
                                    if ($estado == 'Finalizado')
                                    {
                                        $valor_sur .= " Finalizada";
                                    }
                                }     
                                elseif ($posicion == 'SIC') 
                                {
                                    $data = explode(",", $elemento_historial);                                                      
                                                        $tipotra =  dl_textos::dl_limpiar_texto1($data[2]);
                                                        $estact = dl_textos::dl_limpiar_texto1($data[7]);
                                                        $sanitaria = dl_textos::dl_limpiar_texto1($data[15]);                                   
                                                    switch ($tipotra)
                                                        {
                                                            case "GRUPO DE CONEXIONES":
                                                                $tramite_catastro = "Grupo de Conexiones ";
                                                            break;
                                                            case "SOLICITUD DE CONEXION NUEVA":
                                                                $tramite_catastro = "Nueva ";
                                                            break;
                                                            case "SOLICITUD DE CONEXION EXISTENTE":
                                                                $tramite_catastro = "Existente ";
                                                            break;
                                                            case "CERTIFICADO DE NO SANEAMIENTO":
                                                                $tramite_catastro = "Cert no saneam";
                                                            break;
                                                            default:
                                                                $tramite_catastro = "Otros";
                                                        }
                                                    if ($tramite_catastro != 'Otros' && $tramite_catastro != 'Cert no saneam') 
                                                    {   
                                                    switch ($estact)
                                                        {
                                                            case "FIN":
                                                                $tramite_catastro .= "Finalizada";
                                                            break;
                                                            case "PEND. DE INFORME TECNICO":
                                                                $tramite_catastro .= "Pend Inf Tecnico";
                                                            break;
                                                            case "OBSERVADO":
                                                                $tramite_catastro .= "Observado";
                                                            break;
                                                            case "ESTUDIOS Y PROYECTOS":
                                                                $tramite_catastro .= "Estudios y Proyectos";
                                                            break;
                                                            case "PEND. DE APROBAR INSPECCION FINAL":
                                                                $tramite_catastro .= "Pend Aprob Insp";
                                                            break;
                                                            case "PEND. DE APROBAR INSPECCION":
                                                                $tramite_catastro .= "Pend Aprob Insp";
                                                            break;
                                                            case "EN CONSTRUCCION":
                                                                $tramite_catastro .= "en Construccion";
                                                            break;
                                                            case "INICIO":
                                                                $tramite_catastro .= "Inicio";
                                                            break;
                                                            case "EN ESPERA":
                                                                if ($sanitaria == 'HABP' || $sanitaria == 'HABPO')
                                                                {
                                                                $tramite_catastro .= "pendiente en uso";
                                                                }
                                                                else if ($sanitaria == 'SOS' || $sanitaria == 'SINC' || $sanitaria == 'HABSD' || $sanitaria == 'SINS')
                                                                {
                                                                    $tramite_catastro .= "pendiente sin uso";
                                                                }
                                                            break;
                                                            case "PEND. DE VISITA":
                                                                if ($sanitaria == 'HABP' || $sanitaria == 'HABPO')
                                                                {
                                                                $tramite_catastro .= "pendiente en uso";
                                                                }
                                                                else if ($sanitaria == 'SOS' || $sanitaria == 'SINC' || $sanitaria == 'HABSD' || $sanitaria == 'SINS')
                                                                {
                                                                    $tramite_catastro .= "pendiente sin uso";
                                                                }
                                                            break;
                                                            default:
                                                                $tramite_catastro .= "Otros";
                                                        }
                                                    }   
                                }
                        }

    $res = array('sur'=>$valor_sur,'sic'=>$tramite_catastro);
    return $res;
}	

function normalizo_datos($con)
{
set_time_limit(5000);
$sql = "SELECT id, alta_fuent , alta_descr, historial FROM conexiones WHERE 1";
$resultado = mysqli_query($con,$sql);
$cuenta = 0;
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{
			$id = $row["id"];
            $alta_fuent = normaliza($row["alta_fuent"]);
            $alta_descr = normaliza($row["alta_descr"]);
            $historial = normaliza($row["historial"]);
            $sql2 = "UPDATE conexiones SET ALTA_FUENT = '" . $alta_fuent . "',ALTA_DESC='" . $alta_descr . "', HISTORIAL='" . $historial . "' WHERE ID = " . $id;
            $resultado4 = mysqli_query($con,$sql2);
            $cuenta = $cuenta + 1;
        }
    }
}
echo($cuenta . "\br");
}




function normaliza($cadena)
{
	$cade = utf8_encode($cadena);
	$no_permitidas = array ('�','�','�','�','�','�','�','�','�','�','�','�','�','�','�','�','Ù','� ','è','ì','ò','ù','�','�','â','�','î','ô','û','Â','Ê','Î','�','Û','�','ö','Ö','ï','ä','�','�','Ï','Ä','Ë','�','�','�','�','�','�');
	$permitidas= array ('a','e','i','o','u','A','E','I','O','U','n','N','A','E','I','O','U','a','e','i','o','u','c','C','a','e','i','o','u','A','E','I','O','U','u','o','O','i','a','e','U','I','A','E','N','a','e','i','o','u');
	$texto = str_replace($no_permitidas, $permitidas ,$cade);
	return trim($texto);
}



//chequeo fechas________________________________________________________________________________________________________
function chequeo_fechas($con)
{
set_time_limit(5000);
$sql = "SELECT id, historial FROM conexiones WHERE 1";
$resultado = mysqli_query($con,$sql);
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{
		     $row = array_map('utf8_encode',$row);

							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            $historial_array2 = array();
                            foreach($historial_array as $clave2)
                            {
                                $fecha_historial_texto = substr($clave2['fecha'], 0 , 10);
                                try{
                                $fecha_historial = new DateTime($fecha_historial_texto);
                                }
                                catch(Exception $e){
                                    echo ($fecha_historial_texto. "\n");
                                }
                               
                            }  
        }  
    }
    }   
}	
//chequeo fechas________________________________________________________________________________________________________

//corrijo fechas________________________________________________________________________________________________________
function corrijo_fechas($con)
{
set_time_limit(5000);
$sql = "SELECT id, historial FROM conexiones WHERE historial <> ''";
$resultado = mysqli_query($con,$sql);
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{
		     $row = array_map('utf8_encode',$row);

							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            $historial_array2 = array();
                            foreach($historial_array as $clave2)
                            {
                                $fecha_historial_texto = substr($clave2['fecha'], 0 , 10);
                                if ($fecha_historial_texto == '2021-17-05')
                                {
                                    $clave2['fecha'] = "2021-05-17 00-00-00";
                                }
                                if ($fecha_historial_texto == '2021-08-')
                                {
                                    $clave2['fecha'] = "2021-08-01 00-00-00";
                                }
                                if ($fecha_historial_texto == '20')
                                {
                                    $clave2['fecha'] = "2021-05-17 00-00-00";
                                }
                                array_push($historial_array2,$clave2);
                            }  
                            $historial2 = json_encode($historial_array2);
                            $sql2 = "UPDATE conexiones SET historial = '" . $historial2 . "' WHERE id =" . $id;  
                            $resultado2 = mysqli_query($con,$sql2); 
                            echo $sql2 . "\n"; 
        }  
    }
    }   
}	

//corrijo fechas________________________________________________________________________________________________________




//corrijo fechas________________________________________________________________________________________________________
function corrijo_fechas2($con)
{
set_time_limit(50000);
$sql = "SELECT id, historial FROM conexiones WHERE historial <> '' AND id > 169936";
$resultado = mysqli_query($con,$sql);
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{
							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            $historial_array2 = array();
                            foreach($historial_array as $clave2)
                            {
                                $fecha_historial_texto = trim($clave2['fecha']);
                                if (strlen($fecha_historial_texto) < 10)
                                {
                                    $fechafin = "2000-01-01 00:00:00";
                                }
                                else
                                {
                                            
                                            $fecha_array = explode(" ", $fecha_historial_texto);
                                            $ano = 1990;

                                            if (strlen($fecha_array[0]) > 3)
                                            {
                                            $ano = substr($fecha_array[0], 0 , 4);
                                            }    
                                            if ($ano > 2023 || $ano < 1900)
                                            {
                                                $ano = 1990;
                                            }


                                            $mes = 1;
                                            if (strlen($fecha_array[0]) > 6)
                                            {
                                            $mes = substr($fecha_array[0], 5 , 2);
                                            }    
                                            if ($mes > 12 || $mes < 1)
                                            {
                                                $mes = 1;
                                            }
                                            else
                                            {
                                                $mes = intval($mes); 
                                            }

                                            $dia = 1;
                                            if (strlen($fecha_array[0]) > 9)
                                            {
                                            $dia = substr($fecha_array[0], 8 , 2);
                                            }    
                                            if ($dia > 31 || $dia < 1)
                                            {
                                                $dia = 1;
                                            }                               
                                            else
                                            {
                                                $dia = intval($dia); 
                                            }

                                                if (count($fecha_array) > 1)
                                                {            
                                                            $horas = 0;
                                                            if (strlen($fecha_array[1]) > 7)
                                                            {
                                                            $horas = substr($fecha_array[1], 0 , 2);
                                                            }    
                                                            if ($horas > 24 || $horas < 1)
                                                            {
                                                                $horas = 0;
                                                            }
                                                            else
                                                            {
                                                                $horas = intval($horas); 
                                                            }

                                                            $minutos = 0;
                                                            if (strlen($fecha_array[1]) > 7)
                                                            {
                                                            $minutos = substr($fecha_array[1], 3 , 2);
                                                            }    
                                                            if ($minutos > 24 || $minutos < 1)
                                                            {
                                                                $minutos = 0;
                                                            }
                                                            else
                                                            {
                                                                $minutos = intval($minutos); 
                                                            }


                                                            $segundos = 0;
                                                            if (strlen($fecha_array[1]) > 7)
                                                            {
                                                            $segundos = substr($fecha_array[1], 6 , 2);
                                                            }    
                                                            if ($segundos > 24 || $segundos < 1)
                                                            {
                                                                $segundos = 0;
                                                            }
                                                            else
                                                            {
                                                                $segundos = intval($segundos); 
                                                            }
                                                        }
                                                        else
                                                        {
                                                            $horas = 0;
                                                            $minutos = 0;
                                                            $segundos = 0;
                                                        }           

                                            if($mes < 10) {$mes = "0" . $mes;}
                                            if($dia < 10) {$dia = "0" . $dia;}
                                            if($horas < 10) {$horas = "0" . $horas;}
                                            if($minutos < 10) {$minutos = "0" . $minutos;}
                                            if($segundos < 10) {$segundos = "0" . $segundos;}

                                            $fechafin = $ano . "-" . $mes . "-" . $dia . " " . $horas . ":" . $minutos . ":" . $segundos;

                                            $clave2['fecha'] = $fechafin;
                                    }
                                    array_push($historial_array2,$clave2);
                            }

                            $historial2 = json_encode($historial_array2);
                            $sql2 = "UPDATE conexiones SET historial = '" . $historial2 . "' WHERE id =" . $id;  
                            $resultado2 = mysqli_query($con,$sql2); 
                            echo $sql2 . "\n"; 
                                
        }  
    }
    }   
}	

//corrijo fechas________________________________________________________________________________________________________




//recorro historicos________________________________________________________________________________________________________

function borro_sur_viejos($con)
{
set_time_limit(5000);
$sql = "SELECT id, historial FROM conexiones WHERE historial LIKE '%PRESENTE EN SISTEMA UNICO DE RECLAMOS%'";
$resultado = mysqli_query($con,$sql);
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{
		     $row = array_map('utf8_encode',$row);

							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            $historial_array2 = array();
                            foreach($historial_array as $clave2)
                            {
                                $fecha_historial_texto = substr($clave2['fecha'], 0 , 10);
                                $fecha_historial = new DateTime($fecha_historial_texto);
                                $descripcion_historial = $clave2['descripcion'];
                                $posicion = strpos($descripcion_historial,'PRESENTE EN SISTEMA UNICO DE RECLAMOS');
                                if ($posicion === false) {
                                    array_push($historial_array2,$clave2);
                                }
                            }  
                            $historial2 = json_encode($historial_array2);
                            $sql2 = "UPDATE conexiones SET historial = '" . $historial2 . "' WHERE id =" . $id;  
                            $resultado2 = mysqli_query($con,$sql2); 
                            echo $sql2 . "\n"; 
        }  
    }
}	
}
//recorro historicos________________________________________________________________________________________________________




//recorro historicos corrijo padron sur [________________________________________________________________________________________________________

function corrijo_sur($con)
{
set_time_limit(5000);
$sql = "SELECT id, historial FROM conexiones WHERE historial LIKE '%SUR%'";
$resultado = mysqli_query($con,$sql);
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{
		    
							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            $historial_array2 = array();
                            foreach($historial_array as $clave2)
                            {
                                $descripcion_historial = $clave2['descripcion'];
                                $posicion = strpos($descripcion_historial,'[');
                                if ($posicion !== false) {
                                    $descripcion_historial = str_replace("["," ",$descripcion_historial);
                                }
                                $posicion = strpos($descripcion_historial,']');
                                if ($posicion !== false) {
                                    $descripcion_historial = str_replace("]"," ",$descripcion_historial);
                                }
                                $clave2['descripcion'] = $descripcion_historial;
                                array_push($historial_array2,$clave2);
                            }  
                            $historial2 = json_encode($historial_array2);
                            $sql2 = "UPDATE conexiones SET historial = '" . $historial2 . "' WHERE id =" . $id;  
                            $resultado2 = mysqli_query($con,$sql2); 
                            echo $sql2 . "\n"; 
        }  
    }
}	
}
//recorro historicos________________________________________________________________________________________________________



function borro_sur_todos($con)
{
    echo ("empieza borro sur todos......" . PHP_EOL);
set_time_limit(5000);
$sql = "SELECT id, historial FROM conexiones WHERE historial LIKE '%SUR,%'";
$resultado = mysqli_query($con,$sql);
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{
							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            $historial_array2 = array();
                            foreach($historial_array as $clave2)
                            {
                                $fecha_historial_texto = substr($clave2['fecha'], 0 , 10);
                                try{
                                $fecha_historial = new DateTime($fecha_historial_texto);
                                }
                                catch(Exception $e)
                                {
                                 $fecha_historial = new DateTime("2021-04-26");
                                }
                                $descripcion_historial = $clave2['descripcion'];
                                $posicion = substr($descripcion_historial,0,3);
                                if ($posicion != 'SUR') {
                                    array_push($historial_array2,$clave2);
                                }
                            }  
                            $historial2 = json_encode($historial_array2);
                            $sql2 = "UPDATE conexiones SET historial = '" . $historial2 . "' WHERE id =" . $id;  
                            $resultado2 = mysqli_query($con,$sql2); 
                            echo $sql2 . "\n"; 
        }  
    }
}	
}
//recorro historicos________________________________________________________________________________________________________

function borro_sic_todos($con)
{
set_time_limit(5000);
$sql = "SELECT id, historial FROM conexiones WHERE historial LIKE '%SIC,%'";
$resultado = mysqli_query($con,$sql);
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{
							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            $historial_array2 = array();
                            foreach($historial_array as $clave2)
                            {
                                $fecha_historial_texto = substr($clave2['fecha'], 0 , 10);
                                try{
                                $fecha_historial = new DateTime($fecha_historial_texto);
                                }
                                catch(Exception $e)
                                {
                                 $fecha_historial = new DateTime("2021-04-26");
                                }
                                $descripcion_historial = $clave2['descripcion'];
                                $posicion = strpos($descripcion_historial,'SIC,');
                                if ($posicion === false) {
                                    array_push($historial_array2,$clave2);
                                }
                            }  
                            $historial2 = json_encode($historial_array2);
                            $sql2 = "UPDATE conexiones SET historial = '" . $historial2 . "' WHERE id =" . $id;  
                            $resultado2 = mysqli_query($con,$sql2); 
                            echo $sql2 . "\n"; 
        }  
    }
}	
}
//recorro historicos________________________________________________________________________________________________________



function borro_sic_viejos($con)
{
    echo ("empieza borro sic viejos......." . PHP_EOL);
set_time_limit(5000);
$sql = "SELECT id, historial FROM conexiones WHERE historial LIKE '%PRESENTE EN SISTEMA DE CONEXIONES%'";
$resultado = mysqli_query($con,$sql);
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{
							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            $historial_array2 = array();
                            foreach($historial_array as $clave2)
                            {
                                $fecha_historial_texto = substr($clave2['fecha'], 0 , 10);
                                try{
                                $fecha_historial = new DateTime($fecha_historial_texto);
                                }
                                catch(Exception $e)
                                {
                                 $fecha_historial = new DateTime("2021-04-26");
                                }
                                $descripcion_historial = $clave2['descripcion'];
                                $posicion = strpos($descripcion_historial,'PRESENTE EN SISTEMA DE CONEXIONES');
                                if ($posicion === false) {
                                    array_push($historial_array2,$clave2);
                                }
                            }  
                            $historial2 = json_encode($historial_array2);
                            $sql2 = "UPDATE conexiones SET historial = '" . $historial2 . "' WHERE id =" . $id;  
                            $resultado2 = mysqli_query($con,$sql2); 
                            echo $sql2 . "\n"; 
        }  
    }
}	
}
//recorro historicos________________________________________________________________________________________________________



function borro_duplicados_historial_SUR($con)
{
    echo ("empieza borro duplicados......." . PHP_EOL);
set_time_limit(50000);
$sql = "SELECT id, historial FROM conexiones WHERE historial LIKE '%SUR,%'";
$resultado = mysqli_query($con,$sql);
$cant_duplicados = 0;
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{
							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            $historial_array2 = array();
                            foreach($historial_array as $clave)
                            {
                                $yaexiste = false;
                                $fecha_historial = $clave['fecha'];
                                $descripcion_historial = $clave['descripcion'];
                                $usuario_historial = $clave['usuario'];
                                foreach($historial_array2 as $clave2)
                                {
                                    $fecha_historial2 = $clave2['fecha'];
                                    $descripcion_historial2 = $clave2['descripcion'];
                                    $usuario_historial2 = $clave2['usuario'];
                                    if ($fecha_historial == $fecha_historial2 && $descripcion_historial == $descripcion_historial2 && $usuario_historial = $usuario_historial2)
                                    {
                                        $yaexiste = true;
                                    }
                                }    
                                if ($yaexiste === false) {
                                    array_push($historial_array2,$clave);
                                }else
                                {
                                    $cant_duplicados++;
                                }
                            }  
                            $historial2 = json_encode($historial_array2);
                            $sql2 = "UPDATE conexiones SET historial = '" . $historial2 . "' WHERE id =" . $id;  
                            $resultado2 = mysqli_query($con,$sql2); 

        }  
    }
}	
echo "Se eliminaron " . $cant_duplicados . " de historial!"; 
}

//recorro historicos________________________________________________________________________________________________________



function recalculo_campo_sur($con)
{
    echo ("empieza." . PHP_EOL);
set_time_limit(50000);
$sql = "SELECT id, historial FROM conexiones WHERE historial LIKE '%SUR,%'";
$resultado = mysqli_query($con,$sql);
$sql_update = "UPDATE conexiones SET sur = CASE ";
$sql_cierre = " WHERE id in (";
$count = 0;
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{                   
							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            foreach($historial_array as $clave2)
                            {      
                                $descripcion_historial = $clave2['descripcion'];
                                $posicion = substr($descripcion_historial,0,3);
                                if ($posicion == 'SUR') 
                                {
                                    $sur_array = explode(",",$descripcion_historial);
                                    $tipo = $sur_array[2];
                                    $estado = $sur_array[9];
                                    $prioridad = $sur_array[6];
                                    $valor_sur = '';                        

                                    switch ($tipo)
                                    {
                                        case "Conexion Nueva":
                                            $valor_sur = "SUR Nueva";
                                        break;
                                        case "Conexion Rota":
                                            $valor_sur = "SUR Rota";
                                        break;
                                        default:
                                            $valor_sur = "SUR Obstruida";
                                    }
                                    if ($estado != 'Finalizado' && $prioridad == 'Alta')
                                    {
                                        $valor_sur .= " Alta Prioridad";
                                    }
                                    else
                                    if ($estado == 'Finalizado')
                                    {
                                        $valor_sur .= " Finalizada";
                                    } 
                                    if($count > 0 && ($count % 200 ) == 0)
                                    {
                                        $sql_update .= " END " . trim($sql_cierre, ',') . ")";
                                        $resultado7 = mysqli_query($con,$sql_update); 
                                        echo $sql_update . PHP_EOL;
                                        $sql_update = "UPDATE conexiones SET sur = CASE ";
                                        $sql_cierre = " WHERE id in (";
                                    }
                                    $sql_update .= " WHEN id = ". $id . " THEN '" . $valor_sur . "' ";  
                                    $sql_cierre .= $id . ",";
                                    $count++;
                                }
                            }  
        }  
        if (strlen($sql_update) > 35)
        {
            $sql_update .= " END " . trim($sql_cierre, ',') . ")";
            $resultado7 = mysqli_query($con,$sql_update);  
        }
    }
}	

//$resultado2 = mysqli_query($con,$sql2); 
$sql = "UPDATE conexiones SET sur = 'Sin reclamos' WHERE historial NOT LIKE '%SUR,%'";
$resultado = mysqli_query($con,$sql);
//echo "fin";
echo ("fin ok");


}


function creo_tabla_hist($con)
{
    echo ("empieza." . PHP_EOL);
set_time_limit(50000);
$sql = "SELECT id, historial FROM conexiones WHERE historial <> ''";
$resultado = mysqli_query($con,$sql);
$count = 0;
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{                   
							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            foreach($historial_array as $clave2)
                            {      
                                $fecha_historia = substr($clave2['fecha'], 0 ,10);
                                $sql2 = "INSERT INTO conex_hist (id, fecha) VALUES (" . $id . ",'" . $fecha_historia . "')";
                                $resultad2 = mysqli_query($con,$sql2); 
                            }  
        }  
    }
}
//echo "fin";

echo ("fin ok");

}






function cargo_log($con)
{
    echo ("empieza." . PHP_EOL);
set_time_limit(50000);
$lista_eventos = array();
$sql = "SELECT id, historial FROM conexiones WHERE historial <> ''";
$resultado = mysqli_query($con,$sql);
$count = 0;
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{                   
							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            foreach($historial_array as $clave2)
                            {     
                                $descripcion =  substr($clave2['descripcion'], 0 ,4);
                                if ($descripcion != 'ALTA')
                                {
                                    $fecha_historia = substr($clave2['fecha'], 0 ,10);
                                    $elem = array(
                                        'id'=>$id,
                                        'descripcion'=>$clave2['descripcion'],
                                        'fecha'=>$clave2['fecha']
                                    );   
                                    array_push($lista_eventos,$elem);
                                }
                            }  
        }  
    }
}

usort($lista_eventos, function($a, $b) {
    $v1 = strtotime(substr($a['fecha'], 0 , 10));
    $v2 =strtotime(substr($b['fecha'], 0 , 10));
    return $v2 - $v1;
  });

  $lista_eventos = array_slice($lista_eventos, 0, 200);

 
  for($i=0;$i<count($lista_eventos);$i++)
  {
    $sql = "INSERT INTO log (id_conex,descripcion) VALUES (" . $lista_eventos[$i]['id'] . ",'" . $lista_eventos[$i]['descripcion'] . " - Fecha: " . $lista_eventos[$i]['fecha'] . "')";
    //echo $sql . PHP_EOL;
    $resultado = mysqli_query($con,$sql);
  }
  


}




function borro_ccon($con)
{
    echo ("empieza borro sic viejos......." . PHP_EOL);
set_time_limit(50000);
$sql = "SELECT id, historial FROM conexiones WHERE historial LIKE '%CCON,%'";
$resultado = mysqli_query($con,$sql);
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{
							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            $historial_array2 = array();
                            foreach($historial_array as $clave)
                            {
                                $descripcion_historial = $clave['descripcion'];
                                $posicion = strpos($descripcion_historial,'CCON,');
                                if ($posicion === false) {
                                    array_push($historial_array2,$clave);
                                }
                            }  
                            $historial2 = json_encode($historial_array2);
                            $sql2 = "UPDATE conexiones SET historial = '" . $historial2 . "' WHERE id =" . $id;  
                            $resultado2 = mysqli_query($con,$sql2); 
        }  
    }
}	
}


function borro_PRESENTE_EN_SISTEMA_DE_CONEXIONES($con)
{
    echo ("empieza borro sic viejos......." . PHP_EOL);
set_time_limit(50000);
$sql = "SELECT id, historial FROM conexiones WHERE historial LIKE '%PRESENTE EN SISTEMA DE CONEXIONES%'";
$resultado = mysqli_query($con,$sql);
if ($resultado != FALSE){
	if (mysqli_num_rows($resultado) > 0){
		while($row = mysqli_fetch_assoc($resultado))
		{
							$id = $row["id"];
                            $historial = $row["historial"];
                            $historial_array = json_decode($historial,true);
                            $historial_array2 = array();
                            foreach($historial_array as $clave)
                            {
                                $descripcion_historial = $clave['descripcion'];
                                $posicion = strpos($descripcion_historial,'PRESENTE EN SISTEMA DE CONEXIONES');
                                if ($posicion === false) {
                                    array_push($historial_array2,$clave);
                                }
                            }  
                            $historial2 = json_encode($historial_array2);
                            $sql2 = "UPDATE conexiones SET historial = '" . $historial2 . "' WHERE id =" . $id;  
                            $resultado2 = mysqli_query($con,$sql2); 
        }  
    }
}	
}


?>